aboutsummaryrefslogtreecommitdiff
path: root/mail
diff options
context:
space:
mode:
authorrhatto <rhatto@370017ae-e619-0410-ac65-c121f96126d4>2009-01-14 00:42:57 +0000
committerrhatto <rhatto@370017ae-e619-0410-ac65-c121f96126d4>2009-01-14 00:42:57 +0000
commitfb2ec5ee93a7d92325d2c825e90bd54e902b17f5 (patch)
treef9d266748321c94ec20191d6f05822b5d7230906 /mail
parent8ee204d36beb98436e708bf037c9225a432730c7 (diff)
downloadslackbuilds-fb2ec5ee93a7d92325d2c825e90bd54e902b17f5.tar.gz
slackbuilds-fb2ec5ee93a7d92325d2c825e90bd54e902b17f5.tar.bz2
ssmtp: adding ssmtp
git-svn-id: svn+slack://slack.fluxo.info/var/svn/slackbuilds@2081 370017ae-e619-0410-ac65-c121f96126d4
Diffstat (limited to 'mail')
-rw-r--r--mail/mta/ssmtp/Manifest3
-rw-r--r--mail/mta/ssmtp/sstmp.SlackBuild259
2 files changed, 262 insertions, 0 deletions
diff --git a/mail/mta/ssmtp/Manifest b/mail/mta/ssmtp/Manifest
new file mode 100644
index 00000000..cf0cc0eb
--- /dev/null
+++ b/mail/mta/ssmtp/Manifest
@@ -0,0 +1,3 @@
+DIST sstmp_VERSION.orig.tar.gz 53341 MD5 957e6fff08625fe34f4fc33d0925bbc9 RMD160 da76ee6dd86fc663e6fd69fcb2fb5f550f716de7 SHA1 bc4b6c20bf8c2c9e66b359e3c24545a2615a1988 SHA256 2151ad18cb73f9a254f796dde2b48be7318b45410b59fedbb258db5a41044fb5 SHA512 d359da461aa8e78fd274de7787f5b682ec53b71bc077e015ea268741a79d0c82849b94543c7c4caa6ad6c97366be0077bfa3e9fb765f2097dd76ca9e1d6ba413
+MKBUILD ssmtp.mkbuild 4316 MD5 0052b417fb0697f346c5735cf48956cb RMD160 2a6ae028d7136efd9b00867a60ef210b9d97ef2e SHA1 e7e837b5b54b0c0471878e6afb1009a135690e8e SHA256 bbc9c0d81b91d13459aa8f5a50173f470141d2a310787c736ef941cd05906f8e SHA512 0217afc638d4c010eeb76f6078502f64449b8702de7a38918f55486b3f4ff71d57c22f65e19a600784c7b5b6d9e0e7f1fe9705d5e85af1c6060abb9d28bf82c6
+SLACKBUILD sstmp.SlackBuild 8230 MD5 5061a3189178abc5b2ef40ed859f7aff RMD160 27dc5ced1e8f3e9f304648622254967a7a044c5c SHA1 32a53b4a1fe9dd2ef3c14eacebfdb220a5e23888 SHA256 8aa7b1d33973ae4761f09aaaa5c7de4f21ef3fc99bbc7ca026c97d3fcd7b57f6 SHA512 be90a0c279dde6da78bf83843ab1be12fa075d9704b8a310bb56d4fee834a39c886c6ed149338bd07ab25b06af389e0d180f3ebebae95775201344287872d8d3
diff --git a/mail/mta/ssmtp/sstmp.SlackBuild b/mail/mta/ssmtp/sstmp.SlackBuild
new file mode 100644
index 00000000..cd679cac
--- /dev/null
+++ b/mail/mta/ssmtp/sstmp.SlackBuild
@@ -0,0 +1,259 @@
+#!/bin/bash
+#
+# sstmp.SlackBuild is free software; you can redistribute
+# it and/or modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of the License,
+# or any later version.
+#
+# sstmp.SlackBuild is distributed in the hope that it will
+# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+# Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+#
+# slackbuild for sstmp, by Silvio Rhatto
+# requires:
+# tested: sstmp-6.61
+#
+
+# Look for slackbuildrc
+if [ -f ~/.slackbuildrc ]; then
+ source ~/.slackbuildrc
+elif [ -f /etc/slackbuildrc ]; then
+ source /etc/slackbuildrc
+fi
+
+# Set variables
+CWD="$(pwd)"
+SRC_NAME="sstmp"
+PKG_NAME="sstmp"
+ARCH=${ARCH:=i486}
+SRC_VERSION=${VERSION:=6.61}
+PKG_VERSION="$(echo "$SRC_VERSION" | tr '[[:blank:]-]' '_')"
+BUILD=${BUILD:=1rha}
+SRC_DIR=${SRC_DIR:=$CWD}/$PKG_NAME
+TMP=${TMP:=/tmp}
+PKG=${PKG:=$TMP/package-$PKG_NAME}
+REPOS=${REPOS:=$TMP}
+PREFIX=${PREFIX:=/usr}
+PKG_WORK="$TMP/$SRC_NAME"
+CONF_OPTIONS=${CONF_OPTIONS:=""}
+NUMJOBS=${NUMJOBS:=""}
+
+# Set system libraries' path and optmization flags based on $ARCH
+LIBDIR="$PREFIX/lib"
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mtune=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIR="$PREFIX/lib64"
+ LDFLAGS="-L/lib64 -L/usr/lib64"
+fi
+
+# Set error codes (used by createpkg)
+ERROR_WGET=31; ERROR_MAKE=32; ERROR_INSTALL=33
+ERROR_MD5=34; ERROR_CONF=35; ERROR_HELP=36
+ERROR_TAR=37; ERROR_MKPKG=38; ERROR_GPG=39
+ERROR_PATCH=40; ERROR_VCS=41; ERROR_MKDIR=42
+ERROR_MANIFEST=43;
+
+# Clean up any leftovers of previous builds
+rm -rf "$PKG_WORK" 2> /dev/null
+rm -rf "$PKG" 2> /dev/null
+
+# Create directories if necessary
+mkdir -p "$SRC_DIR" || exit $ERROR_MKDIR
+mkdir -p "$PKG" || exit $ERROR_MKDIR
+mkdir -p "$REPOS" || exit $ERROR_MKDIR
+mkdir -p "$PKG_WORK" || exit $ERROR_MKDIR
+
+# Dowload source if necessary
+SRC="$SRC_NAME"_"VERSION.orig.tar.gz"
+URL="http://ftp.de.debian.org/debian/pool/main/s/ssmtp/$SRC"
+
+if [ ! -s "$SRC_DIR/$SRC" ] || ! gunzip -t "$SRC_DIR/$SRC" 2> /dev/null; then
+ wget "$URL" -O "$SRC_DIR/$SRC" || exit $ERROR_WGET
+fi
+
+# Check Manifest file
+if [ -e "$CWD/Manifest" ]; then
+
+ MANIFEST_LINES="`grep -E -v "^(MKBUILD|SLACKBUILD)" $CWD/Manifest | wc -l`"
+
+ for ((MANIFEST_COUNT=1; MANIFEST_COUNT <= $MANIFEST_LINES; MANIFEST_COUNT++)); do
+
+ MANIFEST_LINE="`grep -E -v "^(MKBUILD|SLACKBUILD)" $CWD/Manifest | head -n $MANIFEST_COUNT | tail -n 1`"
+ MANIFEST_FILE="`echo $MANIFEST_LINE | awk '{ print $2 }'`"
+ MANIFEST_FILE_TYPE="`echo $MANIFEST_LINE | awk '{ print $1 }'`"
+
+ if [ -e "$SRC_DIR/$MANIFEST_FILE" ]; then
+ MANIFEST_FILE="$SRC_DIR/$MANIFEST_FILE"
+ else
+ MANIFEST_FILE="`find $CWD -name $MANIFEST_FILE`"
+ fi
+
+ if [ ! -e "$MANIFEST_FILE" ] || [ -d "$MANIFEST_FILE" ]; then
+ continue
+ fi
+
+ echo "Checking Manifest for $MANIFEST_FILE_TYPE $MANIFEST_FILE integrity..."
+
+ SIZE_SRC="`wc -c $MANIFEST_FILE | awk '{ print $1 }'`"
+ SIZE_MANIFEST="`echo $MANIFEST_LINE | awk '{ print $3 }'`"
+
+ # Check source code size
+ if [ "$SIZE_SRC" != "$SIZE_MANIFEST" ]; then
+ echo "SIZE Manifest: $SIZE_MANIFEST; SIZE $SRC: $SIZE_SRC"
+ exit $ERROR_MANIFEST
+ else
+ echo "Size match."
+ fi
+
+ # Check source code integrity
+ for ALGO in md5 rmd160 sha1 sha256 sha512; do
+ if [ $ALGO = "rmd160" ]; then
+ ALGO_SRC="`openssl rmd160 $MANIFEST_FILE | awk '{ print $2 }'`"
+ else
+ ALGO_SRC="`"$ALGO"sum $MANIFEST_FILE | awk '{ print $1 }'`"
+ fi
+ ALGO="`echo $ALGO | tr '[:lower:]' '[:upper:]'`"
+ ALGO_MANIFEST=$(echo $MANIFEST_LINE | sed "s/.* $ALGO //" | awk '{ print $1 }')
+ if [ "$ALGO_SRC" != "$ALGO_MANIFEST" ]; then
+ echo "$ALGO Manifest: $ALGO_MANIFEST; $ALGO $SRC: $ALGO_SRC"
+ exit $ERROR_MANIFEST
+ else
+ echo "$ALGO match."
+ fi
+ done
+
+ done
+
+else
+ exit $ERROR_MANIFEST
+fi
+
+# Untar
+cd "$PKG_WORK"
+tar --no-same-owner --no-same-permissions -xvf "$SRC_DIR/$SRC" || exit $ERROR_TAR
+PKG_SRC="$PWD/`ls -l | awk '/^d/ { print $NF }'`"
+cd "$PKG_SRC"
+
+# Configure
+CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ ./configure \
+ --prefix="$PREFIX" --libdir="$LIBDIR" $CONF_OPTIONS || exit $ERROR_CONF
+
+# Compile
+make $NUMJOBS || exit $ERROR_MAKE
+
+# Install
+mkdir -p $PKG/usr/{sbin,man/man8}
+mkdir -p $PKG/etc/ssmtp
+cp $CWD/ssmtp $PKG/usr/sbin ; chmod 755 $PKG/usr/sbin/ssmtp
+cp $CWD/ssmtp.8 $PKG/usr/man/man8 ; chmod 644 $PKG/usr/man/man8/ssmtp.8
+cp $CWD/ssmtp.conf $PKG/etc/ssmtp/ssmtp.conf.new
+cp $CWD/revaliases $PKG/etc/ssmtp/revaliases.conf.new
+
+# Strip binaries
+( cd "$PKG"
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+)
+
+# Install documentation
+DOCS="CHANGELOG_OLD COPYING INSTALL README TLS"
+mkdir -p "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION" || exit $ERROR_MKDIR
+for doc in $DOCS; do
+ if [ -f "$doc" ]; then
+ cp -a $doc "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION"
+ fi
+done
+
+# Add package description (slack-desc)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EODESC > "$PKG/install/slack-desc"
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler--------------------------------------------------------|
+ssmtp: ssmtp (extremely simple MTA)
+ssmtp:
+ssmtp: This is sSMTP, a program that replaces sendmail on workstations
+ssmtp: that should send their mail via the departmental mailhub from which
+ssmtp: they pick up their mail (via pop, imap, rsmtp, pop_fetch, NFS... or
+ssmtp: the like). This program accepts mail and sends it to the mailhub,
+ssmtp: optionally replacing the domain in the From: line with a different
+ssmtp: one.
+ssmtp:
+ssmtp:
+ssmtp:
+EODESC
+
+# Add a post-installation script (doinst.sh)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EOSCRIPT > "$PKG/install/doinst.sh"
+config() {
+ NEW="\$1"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ OLD="\$(dirname \$NEW)/\$(basename \$OLD .sample)"
+ OLD="\$(dirname \$NEW)/\$(basename \$OLD .dist)"
+
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\$(cat \$OLD | md5sum)" = "\$(cat \$NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+mkgroup() {
+ GROUP="\$1"
+ if ! grep -qe "^\$GROUP:" etc/group; then
+ echo Creating group \$GROUP...
+ chroot . /usr/sbin/groupadd \$GROUP
+ fi
+}
+
+mkuser() {
+ USER="\$1"
+ if [ ! -z "\$2" ]; then
+ GROUP="\$2"
+ else
+ GROUP="\$USER"
+ fi
+ if ! grep -qe "^\$USER:" etc/passwd; then
+ echo Creating user \$USER...
+ chroot . /usr/sbin/useradd \$USER -g \$GROUP
+ fi
+}
+
+config etc/ssmtp/ssmtp.conf.new ; config etc/ssmtp/revaliases.conf.new ; ( cd usr/man/man8 ; rm -rf sendmail.8.gz ) ; ( cd usr/man/man8 ; ln -sf .gz sendmail.8.gz ) ; ( cd usr/sbin ; rm -rf sendmail ) ; ( cd usr/sbin ; ln -sf ssmtp sendmail ) ; ( cd usr/lib ; ln -sf ../sbin/ssmtp sendmail )
+EOSCRIPT
+
+# Build the package
+cd "$PKG"
+makepkg -l y -c n "$REPOS/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.tgz" || exit $ERROR_MKPKG
+
+# Delete source and build directories if requested
+if [ "$CLEANUP" == "yes" ] || [ "$1" = "--cleanup" ]; then
+ rm -rf "$PKG_WORK" "$PKG"
+fi